org.gradle.platform.base.component

## Class BaseComponentSpec

- java.lang.Object
- - org.gradle.platform.base.component.BaseComponentSpec

- All Implemented Interfaces:
    Named, ComponentSpec, org.gradle.platform.base.internal.ComponentSpecInternal

      @Incubating
      public class BaseComponentSpec
      extends Object
      implements org.gradle.platform.base.internal.ComponentSpecInternal

  Base class for custom component implementations. A custom implementation of `ComponentSpec` must extend this type.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Named

      `Named.Namer`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseComponentSpec()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <T extends BaseComponentSpec> T` | `create(Class<? extends ComponentSpec> publicType, Class<T> implementationType, ComponentSpecIdentifier identifier, org.gradle.model.internal.core.MutableModelNode modelNode)`
    `ModelMap<BinarySpec>` | `getBinaries()` The binaries that are built for this component.
    `String` | `getDisplayName()` Returns a human-consumable display name for this component.
    `Set<? extends Class<? extends TransformationFileType>>` | `getInputTypes()`
    `String` | `getName()` The object's name.
    `String` | `getProjectPath()` The path the the project containing this component.
    `ModelMap<LanguageSourceSet>` | `getSource()` The source sets that are used to build this component.
    `ModelMap<LanguageSourceSet>` | `getSources()` The source sets that are used to build this component.
    `protected String` | `getTypeName()`
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BaseComponentSpec

          public BaseComponentSpec()

  - ### Method Detail

    - #### create

          public static <T extends BaseComponentSpec> T create(Class<? extends ComponentSpec> publicType,
                                               Class<T> implementationType,
                                               ComponentSpecIdentifier identifier,
                                               org.gradle.model.internal.core.MutableModelNode modelNode)

    - #### getName

          public String getName()

      Description copied from interface: `Named`
      The object's name.

      Must be constant for the life of the object.

      Specified by:
        `getName` in interface `Named`
      Returns:
        The name. Never null.

    - #### getProjectPath

          public String getProjectPath()

      Description copied from interface: `ComponentSpec`
      The path the the project containing this component.
      Specified by:
        `getProjectPath` in interface `ComponentSpec`

    - #### getTypeName

          protected String getTypeName()

    - #### getDisplayName

          public String getDisplayName()

      Description copied from interface: `ComponentSpec`
      Returns a human-consumable display name for this component.
      Specified by:
        `getDisplayName` in interface `ComponentSpec`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getSource

          public ModelMap<LanguageSourceSet> getSource()

      Description copied from interface: `ComponentSpec`
      The source sets that are used to build this component.
      Specified by:
        `getSource` in interface `ComponentSpec`

    - #### getSources

          public ModelMap<LanguageSourceSet> getSources()

      Description copied from interface: `ComponentSpec`
      The source sets that are used to build this component.
      Specified by:
        `getSources` in interface `ComponentSpec`

    - #### getBinaries

          public ModelMap<BinarySpec> getBinaries()

      Description copied from interface: `ComponentSpec`
      The binaries that are built for this component. You can use this to configure the binaries for this component.
      Specified by:
        `getBinaries` in interface `ComponentSpec`

    - #### getInputTypes

          public Set<? extends Class<? extends TransformationFileType>> getInputTypes()

      Specified by:
        `getInputTypes` in interface `org.gradle.platform.base.internal.ComponentSpecInternal`